import QtQuick 2.0
import Ubuntu.Components 0.1
import Ubuntu.Components.ListItems 0.1 as ListItem
import "../dateutils.js" as DateUtils
import "../databasemodule_v2.js" as DB

UbuntuShape
{
    id: articleTextA

    //property var imageArray: []
    property bool invalid: false
    property var modelItem
    property var rssModel
    property int modelIndex

    width: units.gu(11)
    height: units.gu(20) /*content.height + units.gu(4)*/
    color: invalid ? "black" : modelItem.status == "1" ? Qt.rgba(0, 0, 0, 0.7) : Qt.rgba(0, 0, 0, 0.4)
    radius: "medium"

    onModelItemChanged: {
        if (modelItem == null) {
            invalid = true
        }
    }

    Column {
        id: content

        anchors {
            fill: parent; topMargin: units.gu(2); bottomMargin: units.gu(1.5);
            leftMargin: units.gu(1); rightMargin: units.gu(1.5)
        }
        spacing: units.gu(1)

        Row {
            width: parent.width
            height: labelTime.paintedHeight
            spacing: units.gu(0.5)

            Image {
                id: imgFavourite
                anchors.verticalCenter: labelTime.verticalCenter
                fillMode: Image.PreserveAspectCrop
                source: Qt.resolvedUrl("../icons_tmp/favorite-selected.svg")
                sourceSize.height: invalid ? 0 : (modelItem.favourite == "1" ? units.gu(1.5) : 0)
                visible: invalid ? false : (modelItem.favourite == "1")
            }

            Label {
                id: labelTime
                text: { invalid ? "" : DateUtils.formatRelativeTime(i18n, modelItem.pubdate) }
                fontSize: "x-small"
                width: parent.width - units.gu(2)
                wrapMode: Text.WrapAtWordBoundaryOrAnywhere
                opacity: 0.6
            }
        }

        Label {
            id: labelTitle

            text: invalid ? "" : modelItem.title
            width: parent.width
            height: parent.height - parent.spacing * 2 - labelTime.paintedHeight - labelFeedname.paintedHeight
            wrapMode: Text.WrapAtWordBoundaryOrAnywhere
            fontSize: "small"
            textFormat: Text.PlainText
            font.weight: Font.DemiBold
            elide: Text.ElideRight
            opacity: invalid ? 0.4 : modelItem.status == "1" ? 0.4 : 0.8
        }

        Label {
            id: labelFeedname

            text: invalid? "" : modelItem.feed_name
            fontSize: "x-small"
            width: parent.width
            wrapMode: Text.WrapAtWordBoundaryOrAnywhere
            opacity: 0.6
        }
    }

    MouseArea {
        anchors.fill: parent
        onClicked: {
            mainView.toRssPage(rssModel, modelIndex)
        }
    }
}

